export declare function For<T, U extends JSX.Element>(props: {
    each: readonly T[];
    fallback?: JSX.Element;
    children: (item: T, index: () => number) => U;
}): () => U[];
export declare function Index<T, U extends JSX.Element>(props: {
    each: readonly T[];
    fallback?: JSX.Element;
    children: (item: () => T, index: number) => U;
}): () => U[];
export declare function Show<T>(props: {
    when: T | undefined | null | false;
    fallback?: JSX.Element;
    children: JSX.Element | ((item: T) => JSX.Element);
}): () => JSX.Element;
export declare function Switch(props: {
    fallback?: JSX.Element;
    children: JSX.Element;
}): () => JSX.Element;
declare type MatchProps<T> = {
    when: T | undefined | null | false;
    children: JSX.Element | ((item: T) => JSX.Element);
};
export declare function Match<T>(props: MatchProps<T>): JSX.Element;
export declare function ErrorBoundary(props: {
    fallback: JSX.Element | ((err: any) => JSX.Element);
    children: JSX.Element;
}): () => JSX.Element;
export {};
